// Drawing a point

#include <iostream>
#include <vector>

#include "./common.h"

using namespace std;

GLint window_width = 500;
GLint window_height = 500;

int mouse_pnt[2] = { -1, -1 };

void Display() {
  glClear(GL_COLOR_BUFFER_BIT);
  if (mouse_pnt[0] > -1) {
    // What will this draw?
    // A) A red point under the mouse
    // B) Multiple red points under the mouse
    // C) A green line
    // D) None of the above
    glColor3f(1, 0, 0);
    glPointSize(4.0);
    glBegin(GL_POINTS);
    glVertex2iv(mouse_pnt);
    glEnd();
  }
  glFlush();
  glutSwapBuffers();
}

void Init() {
  glClearColor(1.0, 1.0, 1.0, 1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, window_width, 0, window_height);
  glMatrixMode(GL_MODELVIEW);
}

void Keyboard(unsigned char key, int x, int y) {
  switch (key) {
    case 'q':
      exit(EXIT_SUCCESS);
      break;
  }
}

void Mouse(int button, int state, int x, int y) {
  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) {
      mouse_pnt[0] = x;
      mouse_pnt[1] = y;
    }
  }

  glutPostRedisplay();
}

int main(int argc, char** argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(window_width, window_height);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("lecture 3");
  glutDisplayFunc(Display);
  glutKeyboardFunc(Keyboard);
  glutMouseFunc(Mouse);

  Init();

  glutMainLoop();
}

