// Pencil mode

#include <iostream>
#include <vector>

#include "./common.h"

using namespace std;

GLint window_width = 500;
GLint window_height = 500;

struct Point2 {
  Point2(GLfloat _x, GLfloat _y) : x(_x), y(_y) {}
  GLfloat x, y;
};

vector<Point2> points;

// After the fourth point has been added, how many
// times will the first point have been drawn?
// A) 1
// B) 4
// C) 4 or more
// D) none of the above
void Display() {
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3f(1, 0, 0);
  glPointSize(4.0);
  glBegin(GL_POINTS);
  for (int i = 0; i < points.size(); ++i) {
    glVertex2i(points[i].x, points[i].y);
  }
  glEnd();
  // How can we draw lines like a pencil?
  glFlush();
  glutSwapBuffers();
}

void Init() {
  glClearColor(1.0, 1.0, 1.0, 1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, window_width, 0, window_height);
  glMatrixMode(GL_MODELVIEW);
}

void Keyboard(unsigned char key, int x, int y) {
  switch (key) {
    case 'q':
      exit(EXIT_SUCCESS);
      break;
  }
}

void Mouse(int button, int state, int x, int y) {
  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) {
      points.push_back(Point2(x, window_height-y));
    }
  }

  glutPostRedisplay();
}

void MouseMotion(int x, int y) {
  points.push_back(Point2(x, window_height-y));
  glutPostRedisplay();
}

int main(int argc, char** argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(window_width, window_height);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("lecture 3");
  glutDisplayFunc(Display);
  glutKeyboardFunc(Keyboard);
  glutMouseFunc(Mouse);
  glutMotionFunc(MouseMotion);

  Init();

  glutMainLoop();
}

