// Changing the color

#include <iostream>
#include <vector>

#include "./common.h"

using namespace std;

GLint window_width = 500;
GLint window_height = 500;

struct Point2 {
  Point2(GLint _x, GLint _y) {
    x[0] = _x;
    x[1] = _y;
  }
  operator GLint*() { return x; }
  GLint x[2];
};

struct Color {
  Color(GLfloat _r, GLfloat _g, GLfloat _b) {
    c[0] = _r;
    c[1] = _g;
    c[2] = _b;
  }
  operator GLfloat*() { return c; }
  GLfloat c[3];
};

const Color kRed = Color(1, 0, 0);
const Color kGreen = Color(0, 1, 0);
const Color kBlue = Color(0, 0, 1);

vector<Point2> points;
Color color = kRed;

// I start the program and draw a horizontal line.
// I then change colors to green.  I then draw another
// horizontal line below the original.  What will I see?
// A) A red line and a green line
// B) Two green lines
// C) A green 'z'

// How could I change color with the keyboard?
void Display() {
  glClear(GL_COLOR_BUFFER_BIT);
  glColor3fv(color);
  glLineWidth(2.0);
  glBegin(GL_LINE_STRIP);
  for (int i = 0; i < points.size(); ++i) {
    glVertex2iv(points[i]);
  }
  glEnd();
  glFlush();
  glutSwapBuffers();
}

void Init() {
  glClearColor(1.0, 1.0, 1.0, 1.0);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluOrtho2D(0, window_width, 0, window_height);
  glMatrixMode(GL_MODELVIEW);
}

void Keyboard(unsigned char key, int x, int y) {
  switch (key) {
    case 'q':
      exit(EXIT_SUCCESS);
      break;
  }
}

void Mouse(int button, int state, int x, int y) {
  if (button == GLUT_LEFT_BUTTON) {
    if (state == GLUT_DOWN) {
      points.push_back(Point2(x, window_height-y));
    }
  }

  glutPostRedisplay();
}

void MouseMotion(int x, int y) {
  points.push_back(Point2(x, window_height-y));
  glutPostRedisplay();
}

void Menu(int id) {
  if (id == 1) {
    color = kRed;
  } else if (id == 2) {
    color = kGreen;
  } else if (id == 3) {
    color = kBlue;
  }

  glutPostRedisplay();
}

int main(int argc, char** argv) {
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
  glutInitWindowSize(window_width, window_height);
  glutInitWindowPosition(0, 0);
  glutCreateWindow("lecture 3");
  glutDisplayFunc(Display);
  glutKeyboardFunc(Keyboard);
  glutMouseFunc(Mouse);
  glutMotionFunc(MouseMotion);

  Init();

  glutCreateMenu(Menu);
  glutAddMenuEntry("red", 1);
  glutAddMenuEntry("green", 2);
  glutAddMenuEntry("blue", 3);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  glutMainLoop();
}

